module ZipWith where

import Level
open import Coinduction

open import Data.Nat
open import Data.List using (List; []; _∷_; map)
open import Data.Stream using (Stream; _∷_; iterate; take)

_⇒_ : List Set -> Set -> Set
[]      ⇒ C = C
(A ∷ L) ⇒ C = A → L ⇒ C

{-
zipWith : (L : List Set)(C : Set)(f : _⇒_ L C) → 
  _⇒_ (map Stream L) (Stream C)
zipWith [] C f = {!!}
zipWith (A ∷ L) C f = {!!}
-}

module Nonterm where

  zipWith' : (L : List Set){C : Set}(f : L ⇒ C)
    (k : map Stream L ⇒ Stream C) → map Stream L ⇒ Stream C 
  zipWith' []      c cs = c ∷ ♯ cs
  zipWith' (A ∷ L) f k  = λ { (a ∷ s) → zipWith' L (f a) (k (♭ s)) }

  -- non-termination:
  zipWith : (L : List Set){C : Set}(f : L ⇒ C) → map Stream L ⇒ Stream C
  zipWith L f = zipWith' L f (zipWith L f)


zipWith' : (L : List Set){C : Set}(f : L ⇒ C)
  (k : ∞ (map Stream L ⇒ Stream C)) → map Stream L ⇒ Stream C 
zipWith' []      c cs = c ∷ cs
zipWith' (A ∷ L) f k  = λ { (a ∷ as) → zipWith' L (f a) (♯ (♭ k) (♭ as)) }

zipWith : (L : List Set){C : Set}(f : L ⇒ C) → map Stream L ⇒ Stream C
zipWith L f = zipWith' L f (♯ zipWith L f)

-- testing

nats : Stream ℕ
nats = iterate suc zero

squares : Stream ℕ
squares = zipWith (ℕ ∷ ℕ ∷ []) _*_ nats nats

test = take 6 squares